/* Example of inheritance for CIS 190
   Car.cpp: contains definitions for Car class
   Author: Katherine Gibson
   email:  gibsonk@seas.upenn.edu
   */

#include "Car.h"

using namespace std;
#include <string>
#include <iostream>


Car::Car(int numSeats, double mpg, string color, string fuelType,
	 int numAxles, int numWheels, int maxSpeed, double weight)
  : Vehicle(numAxles, numWheels, maxSpeed, weight)
{
  m_numSeats = numSeats;
  m_MPG      = mpg;
  m_color    = color;
  m_fuelType = fuelType;
}

// overriding function from parent class
void Car::Upgrade()
{
  cout << "Upgrading car... " << endl
       << "Increasing number of seats..." << endl
       << "...from " << m_numSeats;
  m_numSeats += (m_numSeats/2);
  cout << " to " << m_numSeats << "..." << endl << endl
       << "Improving miles per gallon..." << endl 
       << "...from " << m_MPG;
  m_MPG += (m_MPG/5);
  cout << " to " << m_MPG << "..." << endl
       << "UPGRADE COMPLETE" << endl;
  
}

// calls function from child class
void Car::PrintSpecs()
{
  // explicitly calls Vehicle class's PrintSpecs() functions
  Vehicle::PrintSpecs();

  // prints its own Car-only variable specifications
  cout << "Number of seats:  " << m_numSeats << endl
       << "Miles per gallon: " << m_MPG      << endl
       << "Car color:        " << m_color    << endl
       << "Fuel Type:        " << m_fuelType << endl;
}


/* because overriding takes precedence over overloading, 
   we must redeclare the original function from the Vehicle 
   class; we can then declare the function we wish to have
   be an option for overloading in the base class */

// original function from parent class
void Car::Move(double distance)
{
  Vehicle::Move(distance);
}

// overloading function from parent class
void Car::Move(double distance, double avgSpeed)
{
  double time = distance/avgSpeed;
  
  cout << "Attempting to move car " << distance << " miles." << endl
       << "Given provided average speed of " << avgSpeed << "..." << endl
       << "Vehicle can be moved in a minimum of " << time << " minutes."
       << endl << "Moving now..." << endl << "MOVING COMPELETE" << endl;

}
