/* Example of inheritance for CIS 190
   Car.: contains prototypes for Car class
   Author: Katherine Gibson
   email:  gibsonk@seas.upenn.edu
   */

#ifndef _CAR_H
#define _CAR_H

using namespace std;
#include <string>

#include "Vehicle.h"

class Car: public Vehicle {
public:
  // constructor
  Car(int    numSeats = 0,  double mpg      = 0.0, 
      string color    = "", string fuelType = "",
      int numAxles = 0, int    numWheels = 0,     // optional arguments
      int maxSpeed = 0, double weight    = 0.0);  // for Vehicle variables
  /* note that the Car constructor also needs the default arguments for
     the variables that belong to the parent Vehicle class; this is one 
     example of when consts are useful, because the default arguments 
     should match in both the Car and Vehicle constructors, but the 
     compiler will not give an error if they do not */

  // overrides function from parent class
  void Upgrade();

   // overrides and calls function from child class
  void PrintSpecs();

  // overloads function from parent class
  void Move(double distance);
  void Move(double distance, double avgSpeed);
protected:
  int    GetNumSeats();
  double GetMPG();
  string GetColor();
  string GetFuelType();
  void SetNumSeats (int    newNumSeats);
  void SetMPG      (int    newMPG);
  void SetColor    (string newColor);
  void SetFuelType (string newFuelType);
private:
  int m_numSeats;
  double m_MPG;
  string m_color;
  string m_fuelType;
} ;


#endif //_CAR_H
