/* Example of inheritance for CIS 190
   Inher.cpp: contains main()
   Author: Katherine Gibson
   email:  gibsonk@seas.upenn.edu
   */

using namespace std;
#include <string>
#include <iostream>

#include "Vehicle.h"
#include "Car.h"



int main()
{
  Vehicle defV;
  Car     defC;

  Vehicle myVehic(0, 3, 100, 80000);
  Car     myCar  (5, 22.3, "blue", "unleaded", 2, 4, 88, 4000);

  cout << endl 
       << "******************************************" << endl
       << "* PrintSpecs() function is overridden in *" << endl
       << "* child class and also calls the Vehicle *" << endl
       << "* PrintSpecs() function explicitly for   *" << endl
       << "* the variables inherited from Vehicle.  *" << endl
       << "******************************************";

  cout << endl << "\tPrinting default vehicle: " << endl;
  defV.PrintSpecs();
  cout << endl << "\tPrinting default car: " << endl;
  defC.PrintSpecs();


  cout << endl << endl << "\tPrinting custom vehicle: " << endl;
  myVehic.PrintSpecs();
  cout << endl << "\tPrinting custom car: " << endl;
  myCar.PrintSpecs();
  cout << endl << endl;

  cout << endl 
       << "*****************************************" << endl
       << "* Upgrade() function entirely overrides *" << endl
       << "* the function from the parent class,   *" << endl
       << "* and performs an entirely different    *" << endl
       << "* purpose for the child Car class.      *" << endl
       << "*****************************************";

  cout << endl << "\tUpgrade custom vehicle: " << endl;
  myVehic.Upgrade();
  cout << endl << "\tUpgrade custom car: " << endl;
  myCar.Upgrade();
  cout << endl << endl;

  cout << endl 
       << "******************************************" << endl
       << "* Move() function is overloaded in child *" << endl
       << "* class.  Car objects can call either of *" << endl
       << "* the two Move() functions based on the  *" << endl
       << "* arguments passed in; Vehicle objects   *" << endl
       << "* can only invoke the original Move().   *" << endl
       << "******************************************";
  cout << endl << "Move custom vehicle: " << endl;
  myVehic.Move(10000.0);

  cout << endl << "Move custom car given only distance:" << endl;
  myCar.Move(10000.0);

  cout << endl << "Move custom car given distance and average speed:" << endl;
  myCar.Move(1000000000, 77.0);

  cout << endl << endl;

  return 0;
}
