/* Example of inheritance for CIS 190
   Vehicle.h: contains prototypes for Vehicle class
   Author: Katherine Gibson
   email:  gibsonk@seas.upenn.edu
   */

#ifndef _VEHICLE_H
#define _VEHICLE_H


using namespace std;
#include <string>

class Vehicle {
public:
  // constructor
  Vehicle(int numAxles = 0, int    numWheels = 0, 
	  int maxSpeed = 0, double weight    = 0.0);  

  // function that is overriden in child class
  void Upgrade();

  // function that is called in child class
  void PrintSpecs();

  // function that is overloaded in child class
  void Move(double distance);
protected:
  int    GetNumAxles();
  int    GetNumWheels();
  int    GetMaxSpeed();
  double GetWeight();
  void SetNumAxles (int    newAxles);
  void SetNumWheels(int    newWheels);
  void SetMaxSpeed (int    numMaxSpeed);
  void SetWeight   (double newWeight);
private:
  int m_numAxles;
  int m_numWheels;
  int m_maxSpeed;
  double m_weight;
} ;

#endif //_VEHICLE_H
